org &C000
sint1:incbin "sh7100_2.bin";Y
sint2:incbin "sh7000_2.bin";X
;bw:;; db &80,&40,&20,&10
;write direct
;run start

start:

ld sp,stack_here+&100

LD BC,&7F03;pen number (and Gate Array function)
OUT (C),c ;Send pen number

ld a,&40;46
;Pen colour (and Gate Array function)
OUT (C),a


LD BC,&7F01
OUT (C),c

ld a,&4B;51;42
OUT (C),a

ld hl,0;&C000
ld de,1;&C001
ld bc,16384*3-1
ld (hl),l;&F0
ldir

loop:
ld b,#f5
wait_f:
in a,(c)
rra
jr nc,wait_f

;jp border

page:ld a,&FF
inc a
and 3
ld (page+1),a
ld l,a
ld h,0
push hl
add hl,hl
pop bc
 add hl,bc;*3
ld bc,port_l
add hl,bc

ld a,(hl)
inc hl
ld bc,&bc0c;R12/R13
out (c),c
;ld a,%00010000;xxDD00AA
inc b
out (c),a
 
ld bc,&bc0d
out (c),c
xor a
inc b
out (c),a

ld a,(hl)
inc hl
ld bc,&7F00
out (c),a

ld a,(hl)
ld (xorv+1),a

;border:
;; select border
;ld bc,&7f10
;out (c),c
;;; set border colour to black
;ld bc,&7f50
;out (c),c

v1: ld	a, 0
ld	h, sint1/256
ld	l, a
inc	a
cp	&F9
jr	nz, nolp1
xor	a
nolp1:
ld	(v1+1), a
ld l,(hl);Y
ld h,0
push hl

v2: ld	hl,0
inc	l
ld	(v2+1), hl
add hl,hl
ld de,sint2
add hl,de

ld e,(hl);X
inc hl
ld d,(hl)

pop hl

push de
;Input DE = X (0..319), HL = Y (0..199)
FPLOT	LD A, L			;A = Lowbyte Y
	AND %00000111		;isolate Bit 0..2
	LD H, A			;= y MOD 8 to H
	XOR L			;A = Bit 3..7 of Y
	LD L, A			;= (Y\8)*8 to L
	LD C, A			;store in C
	LD B, &60		;B = &C0\2 = Highbyte Screenstart\2
		
	ADD HL, HL		;HL * 2
	ADD HL, HL		;HL * 4
	ADD HL, BC		;+ BC = Startaddress
	ADD HL, HL		;of the raster line
		
;	LD A, E			;Lowbyte X to A
	SRL D			;calculate X\4, because
	RR E			;4 pixel per byte
	SRL E
	ADD HL, DE		;+ HL = Screenaddress
		
pop de

;jp cont
;ld a,e
;and 3
;ld e,a
;ld d,bw/256
;ld a,(de)
;xor (hl)
;ld (hl),a
;
;jp loop
;
;cont:
ex de,hl;de-adr,hl-X

ld a,l;adr X*96=3*32
and 3
ld l,a
ld h,0
add hl,hl
ld bc,balls_a
add hl,bc

ld a,(hl)
inc hl
ld h,(hl)
ld l,a

push hl
ld bc,384;768
pop ix
add ix,bc
;ld de,&C000-check
;ld hl,balls-check
;ld ix,balls+768-check
call maskball

;;; select border
;ld bc,&7f10
;out (c),c
;;; set border colour to black
;ld bc,&7f54
;out (c),c

jp loop
balls_a:
dw balls
dw balls+96
dw balls+192
dw balls+288

port_l:
;for R12,paging,for adres
db %00000000,&C1,&C0;0000
db %00010000,&C1,&80;4000
db %00100000,&C1,&40;8000
;;db %00010000,&C3,&80;p3 at &4000
db %00110000,&C3,&80;p3 at &4000--------------Optimus
maskball:
ld a,16
drwball:
 ex af,af'
 push de

 ld a,d
xorv:xor &00;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ld d,a

ld a,(de);-b1.p1
and(ix)
or (hl)
ld (de),a
inc de
inc hl
inc ix
ld a,(de);-b1.p2
and(ix)
or (hl)
ld (de),a
inc de
inc hl
inc ix

ld a,(de);-b2.p1
and(ix)
or (hl)
ld (de),a
inc de
inc hl
inc ix
ld a,(de);-b2.p2
and(ix)
or (hl)
ld (de),a
inc de
inc hl
inc ix

ld a,(de);-b3.p1
and(ix)
or (hl)
ld (de),a
inc de
inc hl
inc ix
ld a,(de);-b3.p2
and(ix)
or (hl)
ld (de),a
inc de
inc hl
inc ix

 pop de
 ex de,hl
call nline
ex de,hl
ex af,af'
dec a
jp nz,drwball

ret

nline:
  		ld a,8 
        add a,h
        ld h,a 
        and 64 
        ret nz
        ld bc,16304 
        sbc hl,bc 
        ret
balls:;incbin"balls2.bin"
incbin"balls3.bin"
incbin"balls3m.bin"
stack_here: